//
// Created by n0ffie on 08/04/25.
//

#include <iostream>

#include <cigus.hpp>

class NewView : public cigus::UI::View {
public:
	bool update() override
	{
		std::cout << "Update...\n";
		return true;
	}

	void body() override {
		std::cout << "Body\n";
		Rectangle(400,400, sf::Color(20,20,120));
		Rectangle(100, 100, sf::Color(250,250,250));
		Rectangle(10,20, sf::Color(120,120,120));
	}
};

int main(int argc, char** argv) {

	namespace UI = cigus::UI;
	sf::RenderWindow window(sf::VideoMode({800, 600}), "Hello World!");
	window.setFramerateLimit(60);

	const auto view = new NewView();
	const UI::Renderer renderer(view);

	while (window.isOpen()) {

		while (const std::optional event = window.pollEvent())
		{
			if (event->is<sf::Event::Closed>())
			{
				window.close();
			}
		}

		renderer.update();

		window.clear();
		renderer.render(window, sf::RenderStates());
		window.display();
	}

	return 0;
}